# std::_Temporary_buffer< _ForwardIterator, _Tp > Class Template Reference

Inheritance diagram for std::_Temporary_buffer< _ForwardIterator, _Tp >:

List of all members.

## Detailed Description

### template<typename _ForwardIterator, typename _Tp>
class std::_Temporary_buffer< _ForwardIterator, _Tp >

This class is used in two places: stl_algo.h and ext/memory, where it is wrapped as the temporary_buffer class. See temporary_buffer docs for more notes.

Definition at line 127 of file stl_tempbuf.h.

## Public Types

- typedef pointer iterator
- typedef value_type * pointer
- typedef ptrdiff_t size_type
- typedef _Tp value_type

## Public Member Functions

- _Temporary_buffer (_ForwardIterator __first, _ForwardIterator __last)
- iterator begin ()
- iterator end ()
- size_type requested_size () const
- size_type size () const
- ~_Temporary_buffer ()

## Protected Attributes

- pointer _M_buffer
- size_type _M_len
- size_type _M_original_len

## Constructor & Destructor Documentation

template<typename _ForwardIterator, typename _Tp>

std::_Temporary_buffer< _ForwardIterator, _Tp >::_Temporary_buffer | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last |
| ) |  |  |

Constructs a temporary buffer of a size somewhere between zero and the size of the given range.

Definition at line 186 of file stl_tempbuf.h.

References std::_Temporary_buffer< _ForwardIterator, _Tp >::_M_buffer, std::_Temporary_buffer< _ForwardIterator, _Tp >::_M_len, std::_Temporary_buffer< _ForwardIterator, _Tp >::_M_original_len, std::pair< _T1, _T2 >::first, std::get_temporary_buffer(), std::return_temporary_buffer(), std::pair< _T1, _T2 >::second, and std::uninitialized_fill_n().

## Member Function Documentation

template<typename _ForwardIterator, typename _Tp>

iterator std::_Temporary_buffer< _ForwardIterator, _Tp >::begin | ( |  | ) | `[inline]`

As per Table mumble.

Definition at line 156 of file stl_tempbuf.h.

Referenced by std::inplace_merge(), std::stable_partition(), and std::stable_sort().

template<typename _ForwardIterator, typename _Tp>

iterator std::_Temporary_buffer< _ForwardIterator, _Tp >::end | ( |  | ) | `[inline]`

As per Table mumble.

Definition at line 161 of file stl_tempbuf.h.

template<typename _ForwardIterator, typename _Tp>

size_type std::_Temporary_buffer< _ForwardIterator, _Tp >::requested_size | ( |  | ) | const`[inline]`

Returns the size requested by the constructor; may be >size().

Definition at line 151 of file stl_tempbuf.h.

Referenced by std::stable_partition().

template<typename _ForwardIterator, typename _Tp>

size_type std::_Temporary_buffer< _ForwardIterator, _Tp >::size | ( |  | ) | const`[inline]`

As per Table mumble.

Definition at line 146 of file stl_tempbuf.h.

Referenced by std::inplace_merge(), std::stable_partition(), and std::stable_sort().

The documentation for this class was generated from the following file:

- stl_tempbuf.h